#=============================================================================
# 'Strings' commands
#=============================================================================

proc setPrefix {} {
	global prefixString
	if {[catch {prompt "New Prefix String:" $prefixString} res] == 1} return
	set prefixString $res
}

proc setSuffix {} {
	global suffixString
	if {[catch {prompt "New Suffix String:" $suffixString} res] == 1} return
	set suffixString $res
}

proc insertSuffix {} {doSuffix insert}
proc removeSuffix {} {doSuffix remove}
proc doSuffix {which} {
	global suffixString
	set str ${suffixString}\r
	set start [getPos]
	set end [selEnd]
	set start [lineStart $start]
	set end [nextLineStart [expr $end-1]]
	set text [getText $start $end]
	deleteText $start $end
	if {$which == "insert"} then {
		regsub -all \r $text $str text
	} else {
		regsub -all $str $text \r text
	}
	insertText $text
}


proc insertPrefix {} {doPrefix insert}
proc removePrefix {} {doPrefix remove}
proc doPrefix {which} {
	global prefixString
	set str \r$prefixString
	set start [getPos]
	set end [expr [selEnd]-1]
	if {$end<$start} {set end $start}
	set start [lineStart $start]
	set text [getText $start $end]
	if {$which == "insert"} then {
		regsub -all \r $text $str text
		replaceText $start $end $prefixString$text
	} else {
		regsub -all $str $text \r text
		regsub ^$prefixString $text "" text
		replaceText $start $end $text
	}
}


