#===========================================================================
# Debug a Tcl procedure.
#===========================================================================

proc traceTclProc {} {
	set func [listpick -p {Func Name:} [lsort [info procs]]]
	if {![string length $func]} return
	set win [listpick -p {Output window:} [lsort [winNames]]]
	if {![string length $win]} return
	traceFunc on $func $win
	markMenuItem Tcl traceTclProc on
}

proc traceOff {} {
	traceFunc off
	markMenuItem Tcl traceTclProc off
}


proc setTclMode {} {
	changeMode "Tcl"
	uplevel #0 {
		set elecLBrace 0
		set elecRBrace 0
		set electricSemi 0
		set wordWrap 0
		set funcTitle "Proc"
		set funcExpr {^proc *([+-a-zA-Z0-9]+)}
		set wordBreakPreface {[^a-zA-Z0-9_\$]}
		set wordBreak {(\$)?[a-zA-Z0-9_]+}
		set funcPar 1
		set sortedIsDefault 1
		set prefixString "# "
	}
	insertMenu Tcl
}

